//+------------------------------------------------------------------+
//|                                                          CFP.mq4 |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1  DeepSkyBlue
#property indicator_width1  2

//
//
//
//
//

extern string Parameters   = "Indicator parameters";
extern string Prefix       = "";
extern string Suffix       = "";
extern int    MA_Method    =  2;
extern int    Price        =  6;
extern int    Fast         =  3;
extern int    Slow         =  5;
extern bool   USD          = true;
extern bool   EUR          = true;
extern bool   GBP          = true;
extern bool   CHF          = true;
extern bool   JPY          = true;
extern bool   AUD          = true;
extern bool   CAD          = true;
extern bool   NZD          = true;
extern bool   alertsOn           = false;
extern bool   alertsOnCurrent    = true;
extern bool   alertsMessage      = true;
extern bool   alertsNotification = false;
extern bool   alertsSound        = false;
extern bool   alertsEmail        = false;

//
//
//
//
//

double OUT[];
double trend[];
string symbols[];
string indicatorFileName;
bool   returnBars;

//+------------------------------------------------------------------
//| 
//+------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(2);
   SetIndexBuffer(0, OUT); SetIndexLabel(0, Symbol());  SetIndexEmptyValue(0, 0);
   SetIndexBuffer(1, trend);
   IndicatorShortName("CFP (" + Symbol() + ")");
   
      //
      //
      //
      //
      //
      
         indicatorFileName = WindowExpertName();
         returnBars        = (Parameters=="returnBars"); if (returnBars) return(0);

      //
      //
      //
      //
      //         
      
      if (EUR) addSymbol("EURUSD");
      if (GBP) addSymbol("GBPUSD");
      if (AUD) addSymbol("AUDUSD");
      if (NZD) addSymbol("NZDUSD");
      if (CAD) addSymbol("USDCAD");
      if (CHF) addSymbol("USDCHF");
      if (JPY) addSymbol("USDJPY");
      
   return(0);
}

//
//
//
//
//

int  deinit() { return(0); }
void addSymbol(string symbol)
{
   ArrayResize(symbols,ArraySize(symbols)+1); symbols[ArraySize(symbols)-1] = Prefix+symbol+Suffix;
}
int getLimit(int limit, string symbol)
{
   if (symbol!=Symbol())
   {
      limit = MathMax(MathMin(Bars-1,iCustom(symbol,0,indicatorFileName,"returnBars",0,0)),limit);
   }
   return(limit);
}


//+------------------------------------------------------------------
//| 
//+------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int i,limit,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { OUT[0] = limit; return(0); }

         //
         //
         //
         //
         //
                  
         for (int k=0; k<ArraySize(symbols); k++) limit = getLimit(limit,symbols[k]);

   //
   //
   //
   //
   //

   for(i=0; i<=limit; i++)
   {
       if(EUR)
         {
           double EURUSD_Fast = ma("EURUSD", Fast, MA_Method, Price, i);
           double EURUSD_Slow = ma("EURUSD", Slow, MA_Method, Price, i);
                 if(!EURUSD_Fast || !EURUSD_Slow) break;
         }
       if(GBP)
         {
           double GBPUSD_Fast = ma("GBPUSD", Fast, MA_Method, Price, i);
           double GBPUSD_Slow = ma("GBPUSD", Slow, MA_Method, Price, i);
                  if(!GBPUSD_Fast || !GBPUSD_Slow) break;
         }
       if(AUD)
         {
           double AUDUSD_Fast = ma("AUDUSD", Fast, MA_Method, Price, i);
           double AUDUSD_Slow = ma("AUDUSD", Slow, MA_Method, Price, i);
                  if(!AUDUSD_Fast || !AUDUSD_Slow) break;
         }
       if(NZD)
         {
           double NZDUSD_Fast = ma("NZDUSD", Fast, MA_Method, Price, i);
           double NZDUSD_Slow = ma("NZDUSD", Slow, MA_Method, Price, i);
                  if(!NZDUSD_Fast || !NZDUSD_Slow) break;
         }
       if(CAD)
         {
           double USDCAD_Fast = ma("USDCAD", Fast, MA_Method, Price, i);
           double USDCAD_Slow = ma("USDCAD", Slow, MA_Method, Price, i);
                  if(!USDCAD_Fast || !USDCAD_Slow) break;
         }
       if(CHF)
         {
           double USDCHF_Fast = ma("USDCHF", Fast, MA_Method, Price, i);
           double USDCHF_Slow = ma("USDCHF", Slow, MA_Method, Price, i);
                  if(!USDCHF_Fast || !USDCHF_Slow) break;
         }
       if(JPY)
         {
           double USDJPY_Fast = ma("USDJPY", Fast, MA_Method, Price, i);
           double USDJPY_Slow = ma("USDJPY", Slow, MA_Method, Price, i);
                  if(!USDJPY_Fast || !USDJPY_Slow) break;
         }
       
       //
       //
       //
       //
       //
       
       double arrUSD = 0;
       if(USD)
       {
           if(EUR) arrUSD += EURUSD_Slow / EURUSD_Fast - 1;
           if(GBP) arrUSD += GBPUSD_Slow / GBPUSD_Fast - 1;
           if(AUD) arrUSD += AUDUSD_Slow / AUDUSD_Fast - 1;
           if(NZD) arrUSD += NZDUSD_Slow / NZDUSD_Fast - 1;
           if(CHF) arrUSD += USDCHF_Fast / USDCHF_Slow - 1;
           if(CAD) arrUSD += USDCAD_Fast / USDCAD_Slow - 1;
           if(JPY) arrUSD += USDJPY_Fast / USDJPY_Slow - 1;
         }
       double arrEUR = 0;
       if(EUR)
         {
           if(USD) arrEUR +=  EURUSD_Fast / EURUSD_Slow - 1;
           if(GBP) arrEUR += (EURUSD_Fast / GBPUSD_Fast) / (EURUSD_Slow / GBPUSD_Slow) - 1;
           if(AUD) arrEUR += (EURUSD_Fast / AUDUSD_Fast) / (EURUSD_Slow / AUDUSD_Slow) - 1;
           if(NZD) arrEUR += (EURUSD_Fast / NZDUSD_Fast) / (EURUSD_Slow / NZDUSD_Slow) - 1;
           if(CHF) arrEUR += (EURUSD_Fast * USDCHF_Fast) / (EURUSD_Slow * USDCHF_Slow) - 1;
           if(CAD) arrEUR += (EURUSD_Fast * USDCAD_Fast) / (EURUSD_Slow * USDCAD_Slow) - 1;
           if(JPY) arrEUR += (EURUSD_Fast * USDJPY_Fast) / (EURUSD_Slow * USDJPY_Slow) - 1;
         }
       double arrGBP = 0;
       if(GBP)
         {
           if(USD) arrGBP += GBPUSD_Fast/GBPUSD_Slow-1;
           if(EUR) arrGBP += (EURUSD_Slow / GBPUSD_Slow) / (EURUSD_Fast / GBPUSD_Fast) - 1;
           if(AUD) arrGBP += (GBPUSD_Fast / AUDUSD_Fast) / (GBPUSD_Slow / AUDUSD_Slow) - 1;
           if(NZD) arrGBP += (GBPUSD_Fast / NZDUSD_Fast) / (GBPUSD_Slow / NZDUSD_Slow) - 1;
           if(CHF) arrGBP += (GBPUSD_Fast * USDCHF_Fast) / (GBPUSD_Slow * USDCHF_Slow) - 1;
           if(CAD) arrGBP += (GBPUSD_Fast * USDCAD_Fast) / (GBPUSD_Slow * USDCAD_Slow) - 1;
           if(JPY) arrGBP += (GBPUSD_Fast * USDJPY_Fast) / (GBPUSD_Slow * USDJPY_Slow) - 1;
         }
       double arrAUD = 0;
       if(AUD)
         {
           if(USD) arrAUD +=  AUDUSD_Fast / AUDUSD_Slow - 1;
           if(EUR) arrAUD += (EURUSD_Slow / AUDUSD_Slow) / (EURUSD_Fast / AUDUSD_Fast) - 1;
           if(GBP) arrAUD += (GBPUSD_Slow / AUDUSD_Slow) / (GBPUSD_Fast / AUDUSD_Fast) - 1;
           if(NZD) arrAUD += (AUDUSD_Fast / NZDUSD_Fast) / (AUDUSD_Slow / NZDUSD_Slow) - 1;
           if(CHF) arrAUD += (AUDUSD_Fast * USDCHF_Fast) / (AUDUSD_Slow * USDCHF_Slow) - 1;
           if(CAD) arrAUD += (AUDUSD_Fast * USDCAD_Fast) / (AUDUSD_Slow * USDCAD_Slow) - 1;
           if(JPY) arrAUD += (AUDUSD_Fast * USDJPY_Fast) / (AUDUSD_Slow * USDJPY_Slow) - 1;
         }
       double arrNZD = 0;
       if(NZD)
         {
           if(USD) arrNZD +=  NZDUSD_Fast / NZDUSD_Slow - 1;
           if(EUR) arrNZD += (EURUSD_Slow / NZDUSD_Slow) / (EURUSD_Fast / NZDUSD_Fast) - 1;
           if(GBP) arrNZD += (GBPUSD_Slow / NZDUSD_Slow) / (GBPUSD_Fast / NZDUSD_Fast) - 1;
           if(AUD) arrNZD += (AUDUSD_Slow / NZDUSD_Slow) / (AUDUSD_Fast / NZDUSD_Fast) - 1;
           if(CHF) arrNZD += (NZDUSD_Fast * USDCHF_Fast) / (NZDUSD_Slow * USDCHF_Slow) - 1;
           if(CAD) arrNZD += (NZDUSD_Fast * USDCAD_Fast) / (NZDUSD_Slow * USDCAD_Slow) - 1;
           if(JPY) arrNZD += (NZDUSD_Fast * USDJPY_Fast) / (NZDUSD_Slow * USDJPY_Slow) - 1;
         }
       double arrCAD = 0;
       if(CAD)
         {
           if(USD) arrCAD +=  USDCAD_Slow / USDCAD_Fast - 1;
           if(EUR) arrCAD += (EURUSD_Slow * USDCAD_Slow) / (EURUSD_Fast * USDCAD_Fast) - 1;
           if(GBP) arrCAD += (GBPUSD_Slow * USDCAD_Slow) / (GBPUSD_Fast * USDCAD_Fast) - 1;
           if(AUD) arrCAD += (AUDUSD_Slow * USDCAD_Slow) / (AUDUSD_Fast * USDCAD_Fast) - 1;
           if(NZD) arrCAD += (NZDUSD_Slow * USDCAD_Slow) / (NZDUSD_Fast * USDCAD_Fast) - 1;
           if(CHF) arrCAD += (USDCHF_Fast / USDCAD_Fast) / (USDCHF_Slow / USDCAD_Slow) - 1;
           if(JPY) arrCAD += (USDJPY_Fast / USDCAD_Fast) / (USDJPY_Slow / USDCAD_Slow) - 1;
         }
       double arrCHF = 0;
       if(CHF)
         {
           if(USD) arrCHF +=  USDCHF_Slow / USDCHF_Fast - 1;
           if(EUR) arrCHF += (EURUSD_Slow * USDCHF_Slow) / (EURUSD_Fast * USDCHF_Fast) - 1;
           if(GBP) arrCHF += (GBPUSD_Slow * USDCHF_Slow) / (GBPUSD_Fast * USDCHF_Fast) - 1;
           if(AUD) arrCHF += (AUDUSD_Slow * USDCHF_Slow) / (AUDUSD_Fast * USDCHF_Fast) - 1;
           if(NZD) arrCHF += (NZDUSD_Slow * USDCHF_Slow) / (NZDUSD_Fast * USDCHF_Fast) - 1;
           if(CAD) arrCHF += (USDCHF_Slow / USDCAD_Slow) / (USDCHF_Fast / USDCAD_Fast) - 1;
           if(JPY) arrCHF += (USDJPY_Fast / USDCHF_Fast) / (USDJPY_Slow / USDCHF_Slow) - 1;
         }
       double arrJPY = 0;
       if(JPY)
         {
           if(USD) arrJPY +=  USDJPY_Slow / USDJPY_Fast - 1;
           if(EUR) arrJPY += (EURUSD_Slow * USDJPY_Slow) / (EURUSD_Fast * USDJPY_Fast) - 1;
           if(GBP) arrJPY += (GBPUSD_Slow * USDJPY_Slow) / (GBPUSD_Fast * USDJPY_Fast) - 1;
           if(AUD) arrJPY += (AUDUSD_Slow * USDJPY_Slow) / (AUDUSD_Fast * USDJPY_Fast) - 1;
           if(NZD) arrJPY += (NZDUSD_Slow * USDJPY_Slow) / (NZDUSD_Fast * USDJPY_Fast) - 1;
           if(CAD) arrJPY += (USDJPY_Slow / USDCAD_Slow) / (USDJPY_Fast / USDCAD_Fast) - 1;
           if(CHF) arrJPY += (USDJPY_Slow / USDCHF_Slow) / (USDJPY_Fast / USDCHF_Fast) - 1;
         }

       //
       //
       //
       //
       //
                
       OUT[i] = 0;
         if(0 == StringFind(Symbol(), "USD", 0)) OUT[i] += arrUSD;
         if(3 == StringFind(Symbol(), "USD", 0)) OUT[i] -= arrUSD;
         if(0 == StringFind(Symbol(), "EUR", 0)) OUT[i] += arrEUR;
         if(0 == StringFind(Symbol(), "GBP", 0)) OUT[i] += arrGBP;
         if(3 == StringFind(Symbol(), "GBP", 0)) OUT[i] -= arrGBP;
         if(0 == StringFind(Symbol(), "CHF", 0)) OUT[i] += arrCHF;
         if(3 == StringFind(Symbol(), "CHF", 0)) OUT[i] -= arrCHF;
         if(3 == StringFind(Symbol(), "JPY", 0)) OUT[i] -= arrJPY;
         if(0 == StringFind(Symbol(), "CAD", 0)) OUT[i] += arrCAD;
         if(3 == StringFind(Symbol(), "CAD", 0)) OUT[i] -= arrCAD;
         if(0 == StringFind(Symbol(), "AUD", 0)) OUT[i] += arrAUD;
         if(3 == StringFind(Symbol(), "AUD", 0)) OUT[i] -= arrAUD;
         if(0 == StringFind(Symbol(), "NZD", 0)) OUT[i] += arrNZD;
         if(3 == StringFind(Symbol(), "NZD", 0)) OUT[i] -= arrNZD;
   }
   for (; i>0; i--)
   {
      trend[i] = trend[i+1];
         if (OUT[i]>0) trend[i] =  1;
         if (OUT[i]<0) trend[i] = -1;
   }
   manageAlerts();
   return(0);
}


//+------------------------------------------------------------------
//| 
//+------------------------------------------------------------------
//
//
//
//
//

double ma(string sym, int per, int Mode, int Price, int i)
  {
   double res = 0; int k = 1;
   sym = Prefix+sym+Suffix;
   switch(Period())
   {
       case 1:     res += iMA(sym, 0, per*k, 0, Mode, Price,i); k += 5;
       case 5:     res += iMA(sym, 0, per*k, 0, Mode, Price,i); k += 3;
       case 15:    res += iMA(sym, 0, per*k, 0, Mode, Price,i); k += 2;
       case 30:    res += iMA(sym, 0, per*k, 0, Mode, Price,i); k += 2;
       case 60:    res += iMA(sym, 0, per*k, 0, Mode, Price,i); k += 4;
       case 240:   res += iMA(sym, 0, per*k, 0, Mode, Price,i); k += 6;
       case 1440:  res += iMA(sym, 0, per*k, 0, Mode, Price,i); k += 4;
       case 10080: res += iMA(sym, 0, per*k, 0, Mode, Price,i); k += 4;
       case 43200: res += iMA(sym, 0, per*k, 0, Mode, Price,i);
   }
   return(res);
}


//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      
      //
      //
      //
      //
      //
      
      static datetime prevTime1  = 0;
      static string   prevAlert1 = "";
         if (trend[whichBar] != trend[whichBar+1])
         {
            if (trend[whichBar] ==  1) doAlert(prevTime1,prevAlert1," CFP crossed zero line up");
            if (trend[whichBar] == -1) doAlert(prevTime1,prevAlert1," CFP crossed zero line down");
         }
   }
}

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, string doWhat)
{
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[0]) {
       previousAlert  = doWhat;
       previousTime   = Time[0];

       //
       //
       //
       //
       //

       message =  Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+doWhat;
          if (alertsMessage)      Alert(message);
          if (alertsNotification) SendNotification(message);
          if (alertsEmail)        SendMail(StringConcatenate(Symbol(),"CFP "),message);
          if (alertsSound)        PlaySound("alert2.wav");
   }
}

